package {
	import flash.display.Graphics;
	import flash.display.Shape;
	import flash.net.*;
	import flash.sampler.NewObjectSample;
	import flash.text.TextField;
	import flash.text.TextFieldAutoSize;
	import jp.progression.casts.*;
	import jp.progression.commands.display.*;
	import jp.progression.commands.lists.*;
	import jp.progression.commands.managers.*;
	import jp.progression.commands.media.*;
	import jp.progression.commands.net.*;
	import jp.progression.commands.tweens.*;
	import jp.progression.commands.*;
	import jp.progression.data.*;
	import jp.progression.events.*;
	import jp.progression.executors.*;
	
	/**
	 * ...
	 * @author ...
	 */
	public class Preloader extends CastPreloader {
		private var _loadedPerField:TextField;
		private var _progressBar:Shape;
		/**
		 * 新しい Preloader インスタンスを作成します。
		 */
		public function Preloader() {
			// プリローダーが読み込むファイルと、実行形式を指定します。
			super( new URLRequest( "index.swf" ), false, CommandExecutor );
		}
		
		/**
		 * SWF ファイルの読み込みが完了し、stage 及び loaderInfo にアクセス可能になった場合に送出されます。
		 */
		override protected function atReady():void {
			// TextField を作成します。
			_loadedPerField = new TextField();
			_loadedPerField.x = 220;
			_loadedPerField.y = -100;
			_loadedPerField.width = 210;
			_loadedPerField.autoSize = TextFieldAutoSize.CENTER;
			_loadedPerField.text = "Loading ... 0%";
				
			// progressBar を作成します。
			_progressBar = new Shape();
			var gr:Graphics = _progressBar.graphics;
			gr.beginFill(0x000000);
			gr.drawRect(0, 240, 640, 5);
			gr.endFill();
			_progressBar.scaleX = 0;
		}
		
		/**
		 * オブジェクトが読み込みを開始した瞬間に送出されます。
		 * このイベント処理の実行中には、ExecutorObject を使用した非同期処理が行えます。
		 */
		override protected function atCastLoadStart():void {
			addCommand(
				new AddChild( foreground , _loadedPerField ),
				new AddChild( foreground , _progressBar ),
				// テキストフィールドを画面内に移動させます。
				new DoTweener( _loadedPerField, { y:200, time:1 } )
			);
		}
		
		/**
		 * ダウンロード処理を実行中にデータを受信したときに送出されます。
		 */
		override protected function atProgress():void {var percent:Number = bytesLoaded / bytesTotal;
			// progressBar の横幅を、読み込み状態に応じて変化させます。
			_progressBar.scaleX = percent;
			// テキストフィールドの表示内容を、読み込み状態に応じて変化させます。
			_loadedPerField.text = "Loading ... " + Math.round( percent * 100 ) + "%";
		}
		
		/**
		 * オブジェクトが読み込みを完了した瞬間に送出されます。
		 * このイベント処理の実行中には、ExecutorObject を使用した非同期処理が行えます。
		 */
		override protected function atCastLoadComplete():void {
			addCommand(
				// テキストフィールドを画面から消去します。
				new DoTweener( _loadedPerField, { alpha:0, time:1 } ),
				// progressBar を画面から消去します。
				new DoTweener( _progressBar , { alpha:0 , time:1 } ),
				// テキストフィールドを画面から削除します。
				new RemoveChild( foreground, _loadedPerField ),
				// progressBar を画面から削除します。
				new RemoveChild( foreground , _progressBar )
			);
		}
	}
}
