﻿package scenes{
	import jp.progression.casts.*;
	import jp.progression.commands.display.*;
	import jp.progression.commands.lists.*;
	import jp.progression.commands.managers.*;
	import jp.progression.commands.media.*;
	import jp.progression.commands.net.*;
	import jp.progression.commands.tweens.*;
	import jp.progression.commands.*;
	import jp.progression.data.*;
	import jp.progression.events.*;
	import jp.progression.loader.*;
	import jp.progression.*;
	import jp.progression.scenes.*;
	import ui.*;
	
	/**
	 * ...
	 * @author ...
	 */
	public class GalleryScene extends SceneObject {
		private var galleryPage:GalleryPage;
		private var american:AmericanScene;
		private var french:FrenchScene;
		private var mame:MameScene;
		private var americanButton:AmericanButton;
		private var frenchButton:FrenchButton;
		private var mameButton:MameButton;
		public var photoBG:PhotoBG;
		public var base:PhotoBase;
		public var closeButton:CloseButton;
		public var backButton:BackButton;
		public var nextButton:NextButton;
		/**
		 * 新しい MySceneObject インスタンスを作成します。
		 */
		public function GalleryScene( name:String = null, initObject:Object = null ) {
			// 親クラスを初期化する
			super( name, initObject );
			
			// シーンタイトルを設定します。
			title = "title";
			// インスタンスを生成
			galleryPage = new GalleryPage();
			galleryPage.x = 151;
			galleryPage.y = 113;
			// インスタンスを生成
			american = new AmericanScene();
			american.name = "american";
			// シーンを追加
			addScene( american );
			// インスタンスを生成
			french = new FrenchScene();
			french.name = "french";
			// シーンを追加
			addScene( french );
			// インスタンスを生成
			mame = new MameScene();
			mame.name = "mame";
			// シーンを追加
			addScene( mame );
			// インスタンス生成
			americanButton = new AmericanButton();
			americanButton.x = 150;
			americanButton.y = 161;
			// インスタンス生成
			frenchButton = new FrenchButton();
			frenchButton.x = 270;
			frenchButton.y = 161;
			// インスタンス生成
			mameButton = new MameButton();
			mameButton.x = 390;
			mameButton.y = 161;
			// インスタンス生成
			photoBG = new PhotoBG();
			// インスタンス生成
			base = new PhotoBase();
			base.x = 100;
			base.y = 20;
			// インスタンス生成
			closeButton = new CloseButton();
			closeButton.x = 507;
			closeButton.y = 30;
			// インスタンス生成
			backButton = new BackButton();
			backButton.x = 30;
			backButton.y = 220;
			// インスタンス生成
			nextButton = new NextButton();
			nextButton.x = 570;
			nextButton.y = 220;
		}
		
		/**
		 * シーン移動時に目的地がシーンオブジェクト自身もしくは子階層だった場合に、階層が変更された直後に送出されます。
		 * このイベント処理の実行中には、ExecutorObject を使用した非同期処理が行えます。
		 */
		override protected function atSceneLoad():void {
			galleryPage.alpha = 0;
			addCommand(
				new AddChild( container , galleryPage ),
				new DoTweener( galleryPage , { alpha:1 , time:.2 } ),
				new AddChild( container , americanButton ),
				new AddChild( container , frenchButton ),
				new AddChild( container , mameButton )
			);
		}
		
		/**
		 * シーンオブジェクト自身が目的地だった場合に、到達した瞬間に送出されます。
		 * このイベント処理の実行中には、ExecutorObject を使用した非同期処理が行えます。
		 */
		override protected function atSceneInit():void {
			addCommand(
				new RemoveChild( container , photoBG ),
				new RemoveChild( container , base ),
				new RemoveChild( container , closeButton ),
				new RemoveChild( container , backButton ),
				new RemoveChild( container , nextButton )
			);
		}
		
		/**
		 * シーンオブジェクト自身が出発地だった場合に、移動を開始した瞬間に送出されます。
		 * このイベント処理の実行中には、ExecutorObject を使用した非同期処理が行えます。
		 */
		override protected function atSceneGoto():void {
		}
		
		/**
		 * シーン移動時に目的地がシーンオブジェクト自身もしくは親階層だった場合に、階層が変更される直前に送出されます。
		 * このイベント処理の実行中には、ExecutorObject を使用した非同期処理が行えます。
		 */
		override protected function atSceneUnload():void {
			addCommand(
				new DoTweener( galleryPage , { alpha:0 , time:.2 } ),
				new RemoveChild( container , galleryPage ),
				new RemoveChild( container , americanButton ),
				new RemoveChild( container , frenchButton ),
				new RemoveChild( container , mameButton )
			);
		}
	}
}
